PROBLEM LINK:Author: Shivam Gor DIFFICULTY:Easy PREREQUISITES:NONE PROBLEM:Given a string $S$ with length up to $10^5$. You have to find a prefix of $S$ that occurs the maximum number of times as a substring in $S$ (among all prefixes). If there's a tie, pick the longest prefix. EXPLANATION:Clearly, the prefix consisting of the first letter alone occurs the maximum number of times among all prefixes. Because whatever is the answer prefix, the first letter is always a prefix of it. However, it's not necessarily the longest one. To find the longest one, let's maintain a list of all appearances of our string's first letter. Let's say the prefix consisting of the first 2 letters has maximum occurrences as well, what condition should hold? Answer: Every appearance of the string's first letter must be followed immediately by the string's second letter. If one of these appearances was followed by a different letter, then clearly the prefix consisting of 2 letters occurs fewer times. So what are the condition for lengths > 2? (think about it). If our answer's length is $K$ then all appearances of the first letter must be followed by exactly the same $K1$ letters. So after we maintain the list of appearances indices, we keep moving them forward simultaneously one letter at each step (scanning substrings which present a prefix) until some mismatch happens or the last index reaches the end of the string. This solution runs in $O(S)$ We can prove that according to the fact, that our segments built by moving our pointers cannot ever intersect. If 2 of them intersected, it means that at least one of our pointers points to some index with corresponding letter equal to the string's first letter. BUT when we started a substring from the last appearance of our string's first letter, there's no other appearance in front of it, so it's guaranteed that there will be a mismatch (or it reached the end of the string). AUTHOR'S AND TESTER'S SOLUTIONS:
This question is marked "community wiki".
asked 17 Feb, 19:14

I guess, Zfunction was quite good for solving this problem answered 18 Feb, 04:06

Am I the only one who observed the problem poorly and overkilled it by using binary search and string hashing ? Here is the solution link : https://www.codechef.com/viewsolution/23134615 answered 18 Feb, 02:52

I solved it using binary search over length of prefix with KMP algorithm for pattern searching... answered 18 Feb, 07:44
shouldn't it be O(s * log(s)) ?
(18 Feb, 10:05)
Yes it should be... Typo... Thanks..
(18 Feb, 10:35)
(18 Feb, 11:25)
True @shoom...
(18 Feb, 13:29)

I used KMP search algorithm and binary search and hence the overall complexity was somewhat O((N+N+M)logN) or rather O((N+M)logN), multiplied the number of test cases. Can anyone say why is got itself TLEd? Or do I have no clue of the complexity? answered 18 Feb, 07:54
Maybe...
(18 Feb, 08:12)
We have exactly same solution XD
(18 Feb, 08:16)
I replaced my function of KMP algorithm for pattern searching with yours and it got accepted! https://www.codechef.com/viewsolution/23141256 Boy I want to get my hands dirty with your resources XD.
(18 Feb, 08:41)
XDD how !! I thought we both copied it from gfg...
(18 Feb, 08:49)
I have size of LPS=M and you have NN
(18 Feb, 08:52)

can someone explain me what is "Zfunction" ? And how it's related to this problem answered 18 Feb, 09:15

Can someone please help me find fault in my solution, I think I did the same thing as the editorial. Still got a tle. https://www.codechef.com/viewsolution/23132990 I am returning to CP after a while so might be because my coding hands are rusty. answered 18 Feb, 11:52
I think, I had to just break the loop in case of a mismatch, rather just removing those occurances
(18 Feb, 12:01)

Why my correct O(N) solution times out? Please help. Link: https://www.codechef.com/viewsolution/23143675 answered 18 Feb, 12:49

Test cases are very week: O(n^2): submission, O(n): submission Worst case for O(n^2) solution is when all chars are same. :P answered 18 Feb, 16:52

I have studied 'Z'Algorithm from various sources . But to best of my knowledge Z function is O(m+n) algorithm so how can we solve the problem in less than O(n^2) time . Can someone elaborate Correct logic using Z Algorithm answered 18 Feb, 17:09
In Z algo you create a Z array where each index stores the largest substring starting at i and is also a prefix Now cosider the string "abcabcabc" Here the z array looks like this : 0 0 0 6 0 0 3 0 0 In the above array 6 denotes the substring "abcabc" which is also the prefix and 3 denotes the substring "abc" which is also the prefix Now if you look carefully, in the substring you "abcabc" you are getting one time occurence of the prefixes : "a", "ab", "abc","abca","abcab","abcabc". Similarly in the case of "abc".
(20 Feb, 16:45)
So you can keep an array where each index i denotes the occurence of the prefix of length i. So for each nonzero element(say z[i]) in the zarray you update all the elements between the range 1 to z[i] of the frequency array index by adding 1 to them. This will give you an array containing the frequency of all the prefixes. Then you check for the element with largest frequency and for a tie, check for the largest element
(20 Feb, 16:46)
This is my solution in pypy3 : https://www.codechef.com/viewsolution/23144894
(20 Feb, 16:49)

By using KMP, you can do it in O(S) by counting the number of times each prefix occurs in the string. Here is the link to my code  https://www.codechef.com/viewsolution/23145983 Here is the link to the explanation  https://cpalgorithms.com/string/prefixfunction.html. answered 18 Feb, 18:09

if first two characters of a string are same, will the answer be first character always??? answered 18 Feb, 19:35

Can someone provide c++ code for the logic in the editorial? answered 18 Feb, 20:28
Here it is.. https://www.codechef.com/viewsolution/23190005
(23 Feb, 18:29)

Help needed I have solved this problem using LSP like in KMP matching algorithm but not able to pass all the test case. Below is the link of my code. Please help me. answered 19 Feb, 00:35

I didn't understand this. Can somebody please explain. answered 19 Feb, 02:13

Soln with Zalgorithm https://www.codechef.com/viewsolution/23140613